export function createPrinter(config) {
    const { space = "    " } = { ...config };
    const buffer = [];
    let _indent = 0;
    return {
        indent() {
            ++_indent;
        },
        dedent() {
            --_indent;
        },
        print(text) {
            buffer.push(text);
        },
        printIndent() {
            buffer.push(space.repeat(_indent));
        },
        println(line) {
            buffer.push(space.repeat(_indent));
            buffer.push(line);
            buffer.push("\n");
        },
        done() {
            return buffer.join("");
        },
    };
}
