import * as ast from "../ast/index.js";
export interface Visitor {
    visitUrichk: VisitFn<ast.Urichk>;
    visitRule: VisitFn<ast.Rule>;
    visitHead: VisitFn<ast.Head>;
    visitTail: VisitFn<ast.Tail>;
    visitScheme: VisitFn<ast.Scheme>;
    visitAuthority: VisitFn<ast.Authority>;
    visitUserinfo: VisitFn<ast.Userinfo>;
    visitHost: VisitFn<ast.Host>;
    visitPort: VisitFn<ast.Port>;
    visitPath: VisitFn<ast.Path>;
    visitPathFragment: VisitFn<ast.PathFragment>;
    visitStaticPathFragment: VisitFn<ast.StaticPathFragment>;
    visitParamPathFragment: VisitFn<ast.ParamPathFragment>;
    visitTailRule: VisitFn<ast.TailRule>;
    visitTailRuleMatch: VisitFn<ast.TailRuleMatch>;
    visitTailRuleForm: VisitFn<ast.TailRuleForm>;
    visitTailRuleFormPatternRule: VisitFn<ast.TailRuleFormPatternRule>;
    visitTailRulePatternValue: VisitFn<ast.TailRulePatternValue>;
    visitKey: VisitFn<ast.Key>;
    visitArrayToken: VisitFn<ast.Token>;
    visitTailType: VisitFn<ast.Token>;
    visitMatchType: VisitFn<ast.Token>;
    visitCommentGroup: VisitFn<ast.CommentGroup>;
    visitComment: VisitFn<ast.Comment>;
    visitToken: VisitFn<ast.Token>;
}
interface VisitFn<T> {
    (visitor: Visitor, node: T): void;
}
export declare const visitor: Visitor;
export declare function visitStatementBase<T extends ast.StatementBase>(visitor: Visitor, node: T, visit: () => void): void;
export {};
