export function Rule(name: any, symbols: any, postprocess: any): this;
export class Rule {
    constructor(name: any, symbols: any, postprocess: any);
    id: number;
    name: any;
    symbols: any;
    postprocess: any;
    toString(withCursorAt: any): string;
}
export namespace Rule {
    const highestId: number;
}
export function Grammar(rules: any, start: any): void;
export class Grammar {
    constructor(rules: any, start: any);
    rules: any;
    start: any;
    byName: {};
}
export namespace Grammar {
    function fromCompiled(rules: any, start: any): Grammar;
}
export function Parser(rules: any, start: any, options: any): void;
export class Parser {
    constructor(rules: any, start: any, options: any);
    grammar: Grammar;
    options: {
        keepHistory: boolean;
        lexer: any;
    };
    lexer: any;
    lexerState: any;
    table: Column[];
    current: number;
    feed(chunk: any): Parser;
    results: any[] | undefined;
    reportLexerError(lexerError: any): string;
    reportError(token: any): string;
    reportErrorCommon(lexerMessage: any, tokenDisplay: any): string;
    displayStateStack(stateStack: any, lines: any): void;
    getSymbolDisplay(symbol: any): any;
    buildFirstStateStack(state: any, visited: any): any;
    save(): Column;
    restore(column: any): void;
    rewind(index: any): void;
    finish(): any[];
}
export namespace Parser {
    const fail: {};
}
declare function Column(grammar: any, index: any): void;
declare class Column {
    constructor(grammar: any, index: any);
    grammar: any;
    index: any;
    states: any[];
    wants: {};
    scannable: any[];
    completed: {};
    process(nextColumn: any): void;
    predict(exp: any): void;
    complete(left: any, right: any): void;
}
export {};
